;****** Deplacement avec souris en SCREEN 5 ******

;-------------------------------------------------
;*** Directives d'assemblage spcifique AsMSX ***

.bios
.page 2
.rom
.start DEBUT

;---------------------------------------
;*** Adresses des tables du SCREEN 5 ***

NAMTBL equ 0000h
SPRTBL equ 7800h
SPRATR equ 7600h
SPRCOL equ 7400h

PSET equ 57f5h

MIN_X EQU 0 ; Valeurs maxi et mini
MAX_X EQU 255-8
MIN_Y EQU 0
MAX_Y EQU 211-8

;--------------------------
;*** Dbut du programme ***

DEBUT:
call DISSCR ; on coupe l'affichage
ld hl,0f3eah ; on rcupre l'adresse de la couleur d'criture dans hl (zone de communication)
ld [hl],0 ; couleur d'criture en blanc
inc hl ; on rcupre l'adresse de la couleur de fond
ld [hl],0 ; couleur de fond transparente
;inc hl ; on rcupre l'adresse de la couleur de bordure
;ld [hl],0 ; couleur de bordure bleue

;---------------------------
;*** Passage en SCREEN 5 ***

ld a,5 ; on met le numro de SCREEN choisi dans l'accumulateur
call CHGMOD ; appel de la routine BIOS CHGMOD

;-----------
;*** CLS ***

ld hl,NAMTBL ; on met l'adresse de la table des noms dans hl
ld bc,27136 ; on met la longueur en octets de la table des noms (ici 27136) dans
; le registre double bc
xor a ; on annule la valeur de l'accumulateur
call FILVRM ; appel de la routine FILVRM (on remplit la VRAM  partir de l'adresse contenue par hl,
; sur une longueur d'octets contenue par bc, avec la valeur contenue par l'accumulateur
; ici 0, on remplit donc toute la table des noms par rien : on efface l'cran !

;----------------------------
;*** Dfinition du sprite ***

ld hl,SPR_CUR ; on met dans hl l'adresse des donnes qui constituent notre sprite
ld de,SPRTBL ; on met dans de l'adresse de destination
ld bc,8 ; on met dans bc la longueur en octets des donnes  transfrer
call LDIRVM ; on appelle la routine BIOS LDIRVM, qui va copier les donnes indiques dans la VRAM

;---------------------------------------------------
;*** Dfinition des attributs de sprite initiaux ***

ld hl,ATR_INITIAL ; on met hl  l'adresse de dpart des attributs initiaux du sprite
ld de,SPRITES ; le registre de est mis  l'adresse de la zone variable
ld bc,4 ; le registre bc contient le nombre d'octets  transfrer
ldir ; on copie bc (ici 4) octets depuis hl (ATR_INITIAL) vers de (SPRITES)

;---------------------------------
;*** Activation de l'affichage ***

call ENASCR ; on active l'affichage

;-------------------------
;*** Boucle principale ***

LOOP: ; Label de la boucle principale
ld a,12 ; on charge 12 dans l'accumulateur : c'est la valeur qui permet d'initialiser la souris
; dans le port joystick n1
ld ix,01adh ; on fait appelle  une routine (NEWPAD) de la Sub-ROM MSX2, on charge donc l'adresse
; de cette routine dans ix
call 015fh ; appel de la Sub-Rom MSX2 (en 015fh)

ld a,13 ; on charge 13 dans l'accumulateur : c'est la valeur qui va permettre de grer le
; dplacement horizontal de la souris
ld ix,01adh ; voir au-dessus
call 015fh ; idem
call XBORDR ; appel du sous programme de gestion des dplacements horizontaux
ld[SPRITES+1],a ; on remet dans l'adresse de la variable le rsultat

ld a,14 ; toute cette partie est la mme que la prcdente
ld ix,01adh ;  ceci prs que c'est la composante verticale qui
call 015fh ; est traite
call YBORDR ; cette fois !
ld[SPRITES],a

ld a,[SPRITES+1]	; je stocke dans l'accu l'abscisse du sprite
cp 128				; je le compare  128
jr nc,@@TEST1		; si c'est plus grand, je saute  TEST1
ld a,15				; sinon, je place la valeur de couleur normale dans l'accu... 
call COUL_SPR		; ...et j'appelle la sous-routine COUL_SPR
jr BLOC2			; je saute ensuite  l'autre test
@@TEST1:
cp 200				; je compare l'abscisse  200
jr c,@@TEST2		; si c'est plus petit, je saute  TEST2 
ld a,15				; sinon mme traitement qu'au-dessus
call COUL_SPR
jr BLOC2
@@TEST2:
ld a,[SPRITES]		; je charge cette fois l'ordonne dans l'accu
cp 100				; je la compare  100
jr nc,@@TEST3		; si c'est plus grand, je saute  TEST3
ld a,15				; sinon, je remets la couleur 15, bla bla bla...
call COUL_SPR
jr BLOC2
@@TEST3:
cp 150				; je compare maintenant l'ordonne  150
jr c,@@TEST4		; si c'est plus petit je saute  TEST4
ld a,15				; sinon, comme d'habitude.
call COUL_SPR
jr BLOC2
@@TEST4:
ld a,8				; toutes les conditions sont requises pour tre dans ma zone
call COUL_SPR		; je charge la couleur rouge (8) dans l'accu et j'appelle ma sous-routine

BLOC2:
ld a,[SPRITES+1]	; mme principe que prcdemment...
cp 50
jr nc,@@TEST1
ld hl,SPR_CUR		; ... sauf qu'ici je charge l'adresse du patron de sprite normal
call CHG_SPR		; et j'appelle une routine pour le dfinir
jr BOUTON			; saut au test suivant
@@TEST1:			; je vous passe les commentaires de cette partie
cp 100				; c'est le mme principe qu'auparavant...
jr c,@@TEST2
ld hl,SPR_CUR
call CHG_SPR
jr BOUTON
@@TEST2:
ld a,[SPRITES]
cp 50
jr nc,@@TEST3
ld hl,SPR_CUR
call CHG_SPR
jr BOUTON
@@TEST3:
cp 100
jr c,@@TEST4
ld hl,SPR_CUR
call CHG_SPR
jr BOUTON
@@TEST4:			; ici par contre les tests m'amnent ici si je suis dans la zone  traiter
ld hl,SPR_ALT		; je charge dans HL l'adresse du patron "altr"
call CHG_SPR		; et j'appelle la sous-routine qui va modifier l'aspect de mon sprite

BOUTON:
ld a,1				; ma souris est dans le port manette 1 : je charge 1 dans l'accu
call GTTRIG			; appel  la routine BIOS GTTRIG (elle renvoie 0ffh dans l'accu si le bouton est press)
cp 0ffh				; je compare  0ffh pour savoir si le bouton est effectivement press
call z,AFF_POINT	; si oui, j'appelle la sous-routine AFF_POINT

call DUMP ; appel  la sous-routine DUMP (qui permet de transfrer les valeurs en RAM vers la VRAM)
jp LOOP ; on boucle le programme

;-----------------------------------------
;*** Sous-programme d'affichage d'un point ***

AFF_POINT:
ld b,0
ld d,0
ld a,[SPRITES+1]
inc a
inc a
inc a
ld c,a
ld a,[SPRITES]
inc a
inc a
inc a
inc a
ld e,a
ld a,15
call SETATR
call PSET
ret

;-------------------------------------------------
;*** Sous-programme de modification du patron du sprite ***

CHG_SPR:
ld de,SPRTBL 
ld bc,8 
call LDIRVM 
ret

;---------------------------------------------------
;*** Sous-programme de modification de la couleur du sprite ***

COUL_SPR:
ld hl,SPRCOL
ld bc,8
call FILVRM
ret

;------------------------------------------------
;*** Sous programme de transfert vers la VRAM ***

DUMP: ; label du sous-programme
halt ; synchronisation verticale
ld hl,SPRITES ; adresse de dpart
ld de,SPRATR ; adresse d'arrive
ld bc,4 ; longueur du bloc  transfrer (en octets)
call LDIRVM ; appel  la routine BIOS LDIRVM
ret

;------------------------------------------------
;*** Sous programme du dplacement horizontal ***

XBORDR:
BIT 7,A ; vrification du signe du dplacement
JR Z,XBO_S1 ; si ngatif? saut au sous prog de gestion deplacement MAX?
NEG ; Complment  2 de la valeur de A (A=-A)
LD B,A ; sauvegarde de A dans B
LD A,[SPRITES+1] ; rcup du X initial du sprite dans A
SUB B ; On soustrait la valeur inverse du dplacement  A
JR C,XBO_S2 ; Si dpassement saut  valeur mini
CP MIN_X ; comparaison  la valeur mini
RET NC ; retour boucle principale si pas dpassement.
XBO_S2:
LD A,MIN_X ; mise de A  la valeur mini.
RET ; retour boucle principale
XBO_S1:
ld HL,SPRITES+1 ; HL= valeur X du sprite
ADD A,[HL] ; ajout du dplacement au X du sprite
JR C,XBO_S3 ; Si dpassement saut  valeur max
CP MAX_X ; comparaison  valeur max
RET C ; retour boucle principale si dpassement
XBO_S3:
LD A,MAX_X ; A  valeur max
RET ; retour boucle principale

;------------------------------------------------
;*** Sous programme du dplacement vertical ***

YBORDR:
BIT 7,A ; Idem XBORDR, mais pour Y
JP Z,YBO_S1
NEG
LD B,A
LD A,[SPRITES]
SUB B
JR C,YBO_S2
CP MIN_Y
RET NC
YBO_S2:
LD A,MIN_Y
RET
YBO_S1:
ld HL,SPRITES
ADD A,[HL]
CP MAX_Y
RET C
LD A,MAX_Y
RET

;------------------
;*** Constantes ***

ATR_INITIAL:
db 92,124,0,9

SPR_CUR:
db 010h,010h,010h,0eeh,010h,010h,010h,000h

SPR_ALT:
db 081h,042h,03ch,024h,024h,03ch,042h,081h

;-----------------
;*** Variables ***
.page 3

SPRITES:
ds 4